# Overland Changelog
## 0.10.2
More typing fixes.

## 0.10.1
Fixed some typing issues.

## 0.10.0
Return of the Router... and typings. :confused:
- including the first core app, `Routing`
  - this app is automatically added at the end of the app array when Overland is booted
- new tests for Router middleware + app + class

## 0.9.0
The Great Reorganization of 2016
- `typings` directory, Services have been nuked
- `app#init()` is now `app#boot()`
- `app#listen()` is now `app#serve()`
- Views and Tasks have been added to core
- Models, Forms, Router, Assets, i18n, Channels have been extracted into separate packages
- settings now takes an `ssl` object with `key` and `cert` options
- settings now takes a `ports` object with `http`, `https` and `ws` keys for http, https and websockets ports, respectively

## 0.8.1
- added yarn package manager as default package manager

## 0.8.0
Forms API Pt. II - Electric Boogaloo.
- form API changes: fields are now passed as array to be iterated in template, method and action no longer accepted as parameters for `#render()`, csrf and method field no longer automatically included
- added abstract ModelForm class
- added RelationWidget that autopopulates based on Model relations
- updated `csrf` middleware to only throw on forms with a _csrf field and no matching token
- `path` argument is now optional for `router#use()`.
- fixed issue preventing validations from succeeding on related fields
- removed minLength from StringField/TextField JSON schemaType
- nuked ModelManager + `#createVirtualRelationField()` method - I was being an idiot

## 0.7.0
Return of the Forms API!
- added abstract Form and Widget classes
- added BooleanWidget, DateTimeWidget, DateWidget, EmailWidget, FloatWidget, IntegerWidget, SelectWidget, StringWidget, TelephoneWidget, TextWidget
- new dependencies: `google-libphonenumber`, `csrf`
- new built-in middleware: `csrf` - as the name suggests, performs basic csrf validation.

## 0.6.2
- fixed validation issues with FloatField

## 0.6.1
- fixed issue with incorrect typings for inquirer
- reintroduced typings.json

## 0.6.0
- `ctx.render` from dispatch middleware can now be awaited as expected
- added `model::model` accessor
- automated label generation through title case import from `change-case`
- removed `deepIncludes` from `Migration.ts` and created separate file
- fixed various linting errors
- fixed ModelManager saving model in map without app prefix
- removed CodeClimate config until the TSLint package is fixed
- style fixes for field serialization
- added CONTRIBUTING.md
- bumped up coverage to 95%

## 0.5.1
- updated dependency: objection, overland-nunjucks
- removed extraneous typings
- addressed incorrect type signature for
- addressed repeated inquirer stubbing code 

## 0.5.0
- added i18n / l10n API
  - new `settings.ts` optional property `i18n`, specifying a directory of locale files
  - new `settings.ts` optional array property `locales`, specifying available locales for site
  - locale files are JSON hashes of translation key → localized phrase
- added Services API
  - Service class now exported from `overland/core`
  - included in `settings.ts` array property `services`
  - injected into controller constructor via shortname (`EmailService` → `email`)
- new dependency: `change-case`
  - uncamelcase helper removed, `camelcase` library removed
- new feature: Models now stored in `ModelManager` class instead of standard `Map`.
  - allows for creation of "virtual" (i.e., existing but not user-specified) fields for joins
  - `ModelManager` shares `Map`'s set / access / iterate API, so no changes there
- new feature: `RelationField`s now must define static `createVirtualRelationField` method for creating aforementioned virtual fields on relation models
- new feature: Model subclasses now provide a static `jsonSchema` accessor providing JSONSchema information for form validation
  - all fields now now provide `schemaType` accessor providing JSONSchema info
  - `JSONField`s must have their schemaTypes defined manually (natch).
- fixes to `Model#save()`
  - new and existing models can be related through `Model#save()`
- breaking change: `Overland#createRenderContext()` now accepts Koa `ctx` and render `data` as arguments
- breaking change: `Overland#createContext` now provides `urlFor` helper as property of `ctx.router.helpers`.
- breaking change: BigIncrements fields no longer default to PK
- test coverage bumped to 92%
- FormAPI still in-progress

## 0.4.0

- breaking change: render engines are now specified on a per-app basis under the `engine` property
- breaking change: `redirectTo` helper is now `urlFor`;
- updated typings for `route-mapper` and `overland`.
- updated dependencies
- added access modifiers to most accessors
- added variety of helpful errors and tests for said errors
- made `App`, `Controller` classes abstract
- fixed numerous stylistic errors (extra spaces, semicolons, etc.)

## 0.3.0
Updated and included typings files. Tests now passing on Linux, added Coveralls + Travis interation.
- New EnumField Field type.
- Continuation of fixes from 0.2.2.

## 0.2.3
Addressed missing files in source, Issue #4.

## 0.2.2
- PascalCased files with default class exports, fixed errors resulting from those changes.

## 0.2.1
Take three?
- addressed typo'd requires in `src/migrations.ts`.

## 0.2.0
Take two at an initial release. 😑
- a route to a misspelled app name will now throw with the names of all installed apps
- reformatted missing controller error
- includes missing `camelcase` dependency
- removes unnecessary files from .npmignore

## 0.1.0
Initial release.