![Overland](logo.png)

# Overland
## Batteries-included MVC framework powered by Koa.

[![Build Status](https://travis-ci.org/overlandjs/overland.svg?branch=master)](https://travis-ci.org/overlandjs/overland)
[![Coverage Status](https://coveralls.io/repos/github/overlandjs/overland/badge.svg?branch=master)](https://coveralls.io/github/overlandjs/overland?branch=master)
[![npm version](https://badge.fury.io/js/overland.svg)](https://badge.fury.io/js/overland)
![License](https://img.shields.io/badge/license-MIT-blue.svg)
[![Join the chat at https://gitter.im/overlandjs/overland](https://badges.gitter.im/overlandjs/overland.svg)](https://gitter.im/overlandjs/overland?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)

<!-- TOC -->

- [Overland](#overland)
  - [Batteries-included MVC framework powered by Koa.](#batteries-included-mvc-framework-powered-by-koa)
    - [Installation](#installation)
  - [License](#license)

<!-- /TOC -->

Overland is an MVC web application framework inspired by Rails and Django, built on Koa 2.x and oriented toward rapid development using the latest features in JavaScript.

Overland doesn't re-invent the wheel &mdash; if there's a module that performs a task well, Overland takes advantage of it &mdash; Models and DB are provided by Objection.js and Knex, Rails-style routing is provided by Route-Mapper. Accordingly, Overland's core codebase is fairly svelte: in its current state, &lt;2000 lines.

Like in Django, Overland applications are split into 'apps,' self-contained applications that provide discrete bits of functionality. Overland is currently undergoing the Great Reorganization of 2016, so the Readme will be in rough shape for a bit.

### Installation
```bash
yarn install -g ltd
```

## License
Copyright &copy; 2016 Noah Lange

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.